module Harvest
  class Vcs
    attr_reader :current_branch, :project_code

    def self.current_project
      remote_url = `git config --local remote.origin.url`.strip

      URI(remote_url).path.split('/').last.gsub('.git', '')
    end
    
    def initialize(project_code)
      @project_code = project_code
      @current_branch = git_command_for_current_branch[0..-2]
    end

    def ticket_id
      branch_names = current_branch.gsub(/[^0-9a-z]/i, ' ').split
      
      return nil if branch_names.index(project_code).nil?
  
      branch_names[branch_names.index(project_code)+1]
    end
    
    private
    
    def git_command_for_current_branch
      `git rev-parse --abbrev-ref HEAD`
    end
  end
end
